﻿using UnityEngine;
using System.Collections;

public class CameraShake : MonoBehaviour
{
	public static CameraShake main;
	// Transform of the camera to shake. Grabs the gameObject's transform
	// if null.
	public Transform camTransform;

    [HideInInspector]
	// How long the object should shake for.
	public static float shakeDuration = 0f;

    [HideInInspector]
    // Amplitude of the shake. A larger value shakes the camera harder.
    public float shakeAmount = 0.7f;
    [HideInInspector]
    public float decreaseFactor = 1.0f;

	Vector3 originalPos;


	void Awake()
	{
		main = this;

		if (camTransform == null)
		{
			camTransform = GetComponent(typeof(Transform)) as Transform;
		}
	}

	void OnEnable()
	{
		originalPos = camTransform.localPosition;
	}

	void Update()
	{
		if (shakeDuration > 0)
		{
			camTransform.localPosition = originalPos + Random.insideUnitSphere * shakeAmount;

			shakeDuration -= Time.deltaTime * decreaseFactor;
		}
		else
		{
			shakeDuration = 0f;
			camTransform.localPosition = originalPos;
		}
	}
}